# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' WithdrawLimit Class
#'
#' @field currency 
#' @field minimum 
#' @field onetime 
#' @field daily 
#' @field remaining_daily 
#' @field remaining_daily_krw 
#' @field fixed 
#' @field can_withdraw 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
WithdrawLimit <- R6::R6Class(
  'WithdrawLimit',
  public = list(
    `currency` = NULL,
    `minimum` = NULL,
    `onetime` = NULL,
    `daily` = NULL,
    `remaining_daily` = NULL,
    `remaining_daily_krw` = NULL,
    `fixed` = NULL,
    `can_withdraw` = NULL,
    initialize = function(`currency`, `minimum`, `onetime`, `daily`, `remaining_daily`, `remaining_daily_krw`, `fixed`, `can_withdraw`){
      if (!missing(`currency`)) {
        stopifnot(is.character(`currency`), length(`currency`) == 1)
        self$`currency` <- `currency`
      }
      if (!missing(`minimum`)) {
        stopifnot(is.character(`minimum`), length(`minimum`) == 1)
        self$`minimum` <- `minimum`
      }
      if (!missing(`onetime`)) {
        stopifnot(is.character(`onetime`), length(`onetime`) == 1)
        self$`onetime` <- `onetime`
      }
      if (!missing(`daily`)) {
        stopifnot(is.character(`daily`), length(`daily`) == 1)
        self$`daily` <- `daily`
      }
      if (!missing(`remaining_daily`)) {
        stopifnot(is.character(`remaining_daily`), length(`remaining_daily`) == 1)
        self$`remaining_daily` <- `remaining_daily`
      }
      if (!missing(`remaining_daily_krw`)) {
        stopifnot(is.character(`remaining_daily_krw`), length(`remaining_daily_krw`) == 1)
        self$`remaining_daily_krw` <- `remaining_daily_krw`
      }
      if (!missing(`fixed`)) {
        self$`fixed` <- `fixed`
      }
      if (!missing(`can_withdraw`)) {
        self$`can_withdraw` <- `can_withdraw`
      }
    },
    toJSON = function() {
      WithdrawLimitObject <- list()
      if (!is.null(self$`currency`)) {
        WithdrawLimitObject[['currency']] <- self$`currency`
      }
      if (!is.null(self$`minimum`)) {
        WithdrawLimitObject[['minimum']] <- self$`minimum`
      }
      if (!is.null(self$`onetime`)) {
        WithdrawLimitObject[['onetime']] <- self$`onetime`
      }
      if (!is.null(self$`daily`)) {
        WithdrawLimitObject[['daily']] <- self$`daily`
      }
      if (!is.null(self$`remaining_daily`)) {
        WithdrawLimitObject[['remaining_daily']] <- self$`remaining_daily`
      }
      if (!is.null(self$`remaining_daily_krw`)) {
        WithdrawLimitObject[['remaining_daily_krw']] <- self$`remaining_daily_krw`
      }
      if (!is.null(self$`fixed`)) {
        WithdrawLimitObject[['fixed']] <- self$`fixed`
      }
      if (!is.null(self$`can_withdraw`)) {
        WithdrawLimitObject[['can_withdraw']] <- self$`can_withdraw`
      }

      WithdrawLimitObject
    },
    fromJSON = function(WithdrawLimitJson) {
      WithdrawLimitObject <- jsonlite::fromJSON(WithdrawLimitJson)
      if (!is.null(WithdrawLimitObject$`currency`)) {
        self$`currency` <- WithdrawLimitObject$`currency`
      }
      if (!is.null(WithdrawLimitObject$`minimum`)) {
        self$`minimum` <- WithdrawLimitObject$`minimum`
      }
      if (!is.null(WithdrawLimitObject$`onetime`)) {
        self$`onetime` <- WithdrawLimitObject$`onetime`
      }
      if (!is.null(WithdrawLimitObject$`daily`)) {
        self$`daily` <- WithdrawLimitObject$`daily`
      }
      if (!is.null(WithdrawLimitObject$`remaining_daily`)) {
        self$`remaining_daily` <- WithdrawLimitObject$`remaining_daily`
      }
      if (!is.null(WithdrawLimitObject$`remaining_daily_krw`)) {
        self$`remaining_daily_krw` <- WithdrawLimitObject$`remaining_daily_krw`
      }
      if (!is.null(WithdrawLimitObject$`fixed`)) {
        self$`fixed` <- WithdrawLimitObject$`fixed`
      }
      if (!is.null(WithdrawLimitObject$`can_withdraw`)) {
        self$`can_withdraw` <- WithdrawLimitObject$`can_withdraw`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "currency": %s,
           "minimum": %s,
           "onetime": %s,
           "daily": %s,
           "remaining_daily": %s,
           "remaining_daily_krw": %s,
           "fixed": %s,
           "can_withdraw": %s
        }',
        self$`currency`,
        self$`minimum`,
        self$`onetime`,
        self$`daily`,
        self$`remaining_daily`,
        self$`remaining_daily_krw`,
        self$`fixed`,
        self$`can_withdraw`
      )
    },
    fromJSONString = function(WithdrawLimitJson) {
      WithdrawLimitObject <- jsonlite::fromJSON(WithdrawLimitJson)
      self$`currency` <- WithdrawLimitObject$`currency`
      self$`minimum` <- WithdrawLimitObject$`minimum`
      self$`onetime` <- WithdrawLimitObject$`onetime`
      self$`daily` <- WithdrawLimitObject$`daily`
      self$`remaining_daily` <- WithdrawLimitObject$`remaining_daily`
      self$`remaining_daily_krw` <- WithdrawLimitObject$`remaining_daily_krw`
      self$`fixed` <- WithdrawLimitObject$`fixed`
      self$`can_withdraw` <- WithdrawLimitObject$`can_withdraw`
    }
  )
)
